.nolist
    include     \masm32\include\masm32rt.inc    ; defaults to .386
    .586
    include     \masm32\macros\timers.asm      ; requires a pentium

    LOOPCOUNT equ 1000000

    PROCS TEXTEQU <Borland, szLength,Ratch,Hutch,Jens_fast_strlen,lszLenSSE,roticvSSE, Biterider,Jens_mmx2,LingoMMX,LingoSSE2>
    LastString= 999
    SIZES TEXTEQU <0,1,2,3,5,8,13,22,39,55,89,144,239,LastString>

    HPROC TEXTEQU <szLen>        ; Function to calculate length for header
.listall
    %FOR proc,<PROCS>
        proc proto :DWORD
    ENDM

    MAXWIDTH  equ 20
    HDRWIDTH  equ 9
    COLWIDTH  equ 5

.data

    %FOR extra,<0,1,2,3>
        %FOR len,<SIZES>
            align 16
            db extra dup (0)
            str&extra&b&len& db len dup (254),0
            db 8 dup (255),0    ; possible next string
        ENDM
    ENDM

.code
align 16

sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD
    .if DDalign == 0                    ; align left?
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1                ; align right?
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4

sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>       ; Default is align left
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM

align 16
start:
    ; make a real test string with all ascii characters-
    %FOR extra,<0,1,2,3>
        mov edx,offset str&extra&bLastString
        mov al,1
        mov ecx,LastString
@@:     
        mov [edx],al
        inc al
        .if al==0
            inc al
        .endif
        inc edx
        dec ecx
        jnz @b
    endm        
         
    print chr$("Test routines for correctness:",13,10)
    %FOR extra,<0,1,2,3>
        print chr$("&extra& byte misalignment",13,10)
        %FOR proc,<PROCS>
            print fld$(chr$("&proc&"),HDRWIDTH)
            %FOR len,<SIZES>
                invoke proc,ADDR str&extra&b&len&
                ;invoke proc,ADDR str2b&len&
                print fld$(sstr$(eax),COLWIDTH,1)
            ENDM
            print chr$(13,10)
        ENDM
    ENDM

    print chr$(13,10)
    print fld$(chr$("Proc/Bytes"),HDRWIDTH)

    %FOR len,<SIZES>
        invoke HPROC, ADDR str0b&len&
        print fld$(sstr$(eax),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("=========="),HDRWIDTH)
    %FOR len,<SIZES>
        invoke StrLen,ADDR str0b&len&
        print fld$(" ====",COLWIDTH)
    ENDM
    print chr$(13,10)

    %FOR extra,<0,1,2,3>
        print chr$(13,10)
        print chr$("&extra& byte misalignment",13,10)
       %FOR proc,<PROCS>
            print fld$(chr$("&proc&"),HDRWIDTH)
            %FOR len,<SIZES>
                counter_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
                invoke proc,ADDR str&extra&b&len&
                counter_end
                mov ebx,eax
                print fld$(sstr$(ebx),COLWIDTH,1)
            ENDM
        print chr$(13,10)
        ENDM
    ENDM
    mov   eax,input(13,10,"Press enter to exit...")
    exit

; --------------------- Routines under test ---------------------------------------------

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

szLength proc src:DWORD
            mov     eax, [esp + 4]          ; point eax to start of string
            test    eax, 3
            jnz     fixalign                ; jmp to fix misalignment
            align   4
zscan:      mov     edx, [eax]              ; load next four bytes
resume:     lea     ecx, [edx - 1010101h]
            not     edx                     ; on each byte in edx: (byte-1) & ~byte & 80h
            and     edx, 80808080h
            and     edx, ecx
            jnz     found                   ; branch if found

            mov     edx, [eax + 4]          ; load next four bytes
            add     eax, 8                  ; advance ptr (twice)
            lea     ecx, [edx - 1010101h]
            not     edx                     ; on each byte in edx: (byte-1) & ~byte & 80h
            and     edx, 80808080h
            and     edx, ecx
            jz      zscan                   ; repeat while no zeros found
            sub     eax, 4                  ; back off to last dword
            align   4
found:      sub     eax, [esp + 4]          ; subtract the base address
            test    edx, 8080h              ; test first two bytes
            jz      upper2                  ; jmp if not found in the lower 2 bytes
            shr     edx, 8                  ; set carry from bit7 of 1st byte
            sbb     eax, -1                 ; return eax = eax + (1-carry)
            ret     4
upper2:     shl     edx, 9                  ; set carry from bit7 of 3rd byte
            sbb     eax, -3                 ; return eax = (eax+2) + (1-carry)
            ret     1*4

        align   4
fixalign:   mov     ecx, eax
            and     eax,not 3           ; eax points to aligned addr            
            and     ecx, 3                  ; ecx = bytes to skip
            mov     edx, 1
            shl     ecx, 3                  ; ecx = bits to skip
            shl     edx, cl                 ; put cl 1's into edx from the bottom up
        mov     ecx, [eax]              ; preload 1st word into ecx
            sub     edx, 1
            or      edx, ecx                ; combine with first four bytes
            jmp     resume                  ; start up in the aligned search
szLength endp


align 16

Ratch proc junk:dword      ; from Ratch           ;it all begins here
    MOV EAX,[ESP+DWORD]       ;address of string

    .REPEAT                   ;searching string ....
        MOV EDX,[EAX]           ;next 4 byte gulp (DWORD)
        ADD EAX,DWORD           ;EAX=character pointer
        LEA ECX,[EDX-01010101H] ;propagate if byte is zero
        NOT EDX                 ;set up test pattern
        AND EDX,ECX             ;leftmost bit of zero byte should now be set
        AND EDX,080808080H      ;sieve out zero bytes
    .UNTIL !ZERO?             ;check the next DWORD

                           ;we now know the current DWORD contains a zero byte
    SUB EAX,DWORD+BYTE        ;compensate for entry additions into loops

    .REPEAT                   ;searching current DWORD ...
        INC EAX                 ;increase word count if no carry from shift
        ROR EDX,8               ;bring leftmost bit of each byte into carry flag
    .UNTIL CARRY?             ;if carry flag set, byte is zero

    SUB EAX,[ESP+DWORD]       ;subtract beginning of string to get length

    RET DWORD                 ;all done, and string length in EAX

Ratch endp

align 16

Jens_fast_strlen PROC item:DWORD

    mov ecx, [esp+4] 
    
@@:
    mov eax, dword ptr [ecx]
    add ecx, 4
    
    lea edx, [eax - 01010101h]
    xor eax, edx
    and eax, 80808080h
    jz @B
    and eax, edx
    jz @B
    
    bsf edx, eax
    
    sub edx, 4
    shr edx, 3
    
    lea eax, [ecx + edx - 4]
    sub eax, [esp+4] 
    
    RET 4

Jens_fast_strlen ENDP

;--------------   routines using mmx/sse ---------------------------------------------------------------
.xmm

align 16
roticvSSE proc lpstring:dword
        mov     eax, [esp+4]
        cmp     byte ptr[eax], 0
        mov     ecx, eax
        jz      done
        and     ecx, 0FFFFFFF8h
        add     ecx, 8
        sub     ecx, eax
        cmp     ecx, 8
        jz      aligned
    @@:
        add     eax, 1              ;Simple byte scanner for alignment
        cmp     byte ptr[eax],0
        jz      done
        sub     ecx, 1
        jnz     @B
    aligned:
        pxor    mm1, mm1
        align 16
    @@:
        movq    mm0, [eax]
        pcmpeqb mm0,mm1
        add     eax, 8
        pmovmskb ecx,mm0
        test    ecx, ecx
        jz      @B
        bsf     ecx, ecx
        emms
        lea     eax, [eax+ecx-8]
    done:
        sub     eax, [esp+4]
        retn 4
roticvSSE endp

align 16

lszLenSSE proc pString:DWORD    ; Donkey's SSE strlen for long strings
        mov eax,[esp+4]
        nop
        nop                     ; fill in stack frame+mov to 8 bytes

        pxor mm0,mm0
        nop                     ; fill pxor to 4 bytes
        pxor mm1,mm1
        nop                     ; fill pxor to 4 bytes

    @@:                         ; this is aligned to 16 bytes
        movq mm0,[eax]
        pcmpeqb mm0,mm1
        add eax,8
        pmovmskb ecx,mm0
        or ecx,ecx
        jz @B

        sub eax,[esp+4]

        bsf ecx,ecx
        sub eax,8
        add eax,ecx

        emms

        ret 1*4

lszLenSSE endp
    
align 16
Jens_mmx2 proc lpString:DWORD   ; modified to assume mmx available

    CheckForMMx = 0 ; assume mmx available

    if CheckForMMx NE 0
        mov eax, 1 ; request CPU feature flags  ; how to check for mmx if desired
        cpuid ; CPUID instruction
    endif

;- Pre-Scan to align the string-start ----
    mov ecx, [esp+4]
    mov eax, ecx
    cmp byte ptr [eax], 0
    je done
    and ecx, 0FFFFFFF8h
    add ecx, 8
    sub ecx, eax
    cmp ecx, 8
    je aligned
@@:
    inc eax
    cmp byte ptr [eax], 0
    je done
    dec ecx
    jnz @B

aligned:
    mov ecx, eax

    if CheckForMMx ne 0
        test edx, 800000h ; test bit 23 to see if MMX available
        jz no_mmx ; jump if no MMX is available
    endif

    pxor mm0, mm0

@@:
    movq mm1, qword ptr [ecx]
    movq mm2, qword ptr [ecx + 8]
    movq mm3, qword ptr [ecx + 16]
    movq mm4, qword ptr [ecx + 24]
    movq mm5, qword ptr [ecx + 32]
    movq mm6, qword ptr [ecx + 40]
    
    pcmpeqb mm1, mm0
    pcmpeqb mm2, mm0
    pcmpeqb mm3, mm0
    pcmpeqb mm4, mm0
    pcmpeqb mm5, mm0
    pcmpeqb mm6, mm0
    
    por mm1, mm2
    por mm3, mm4
    por mm5, mm6
    por mm1, mm3
    por mm1, mm5
    
    add ecx, 48
    
    packsswb mm1, mm1
    movd eax, mm1
    test eax, eax
    jz @B
    
    sub ecx, 48

    emms ; Empty MMX state

no_mmx:

@@:
    mov eax, dword ptr [ecx]
    add ecx, 4
    
    lea edx, [eax - 01010101h]
    xor eax, edx
    and eax, 80808080h
    and eax, edx
    jz @B

    bsf edx, eax
    
    sub edx, 4
    shr edx, 3
    
    lea eax, [ecx + edx - 4]

done:

    sub eax, [esp+4]
    ret 4

Jens_mmx2 endp
;....................................................................................................................................
comment		* StrLen by Biterider  *

Biterider				proc pString:dword
		mov				eax, [esp + 4]    ; eax = base address to start search
		mov				ecx, eax
		and				eax, not 7        ; pull down to aligned address
		and				ecx, 7            ; ecx = pre-read bytes to skip
		movq				mm1, [eax]       ; load first 8 bytes, aligned
		pxor				mm0, mm0         ; mm0 = 0's
		pcmpeqb		mm1, mm0      ; check 8 bytes for zeros
		pmovmskb	edx, mm1     ; edx holds a 1-bit for each zero byte (in the low 8 bits)
		shr				edx, cl           ; discard the pre-read
		test				edx, edx         ; test edx for zero
		jz					more12            ; branch ahead if no zero bytes found
    ;emms
		bsf				eax, edx          ; return the bit position as the length
		ret				4
more12:
		add				eax, 8
again12:   
		movq				mm1, [eax]  
		pcmpeqb		mm1, mm0      ; search the 8-bytes
		add				eax, 8            ; eax = address of 8-byte compare
		pmovmskb	edx, mm1     
		test				edx, edx
		jz					again12
		bsf				edx, edx          ; get position of 1st zero byte
		;emms 
		sub				eax, [esp + 4]    ; subtract original base address
		lea				eax, [eax + edx - 8]   ; add for base address
		ret				4
Biterider				endp
;....................................................................................................................................
comment		* StrLen by kunt0r  *

Borland	proc	xstr:dword

				mov	eax, dword ptr [esp+4]
d1:			mov	edx, dword ptr [eax]
				mov	ecx, edx
				add	eax, 4
				sub	edx, 16843009
				and	edx, 2155905152
				jz		d1
				not	ecx
				and	edx, ecx
				jz		d1
				test	dl, dl
				jnz	d2
				test	dh, dh
				jnz	d3
				test	edx, 16711680
				jnz	d4
				jmp	d5
d2:			dec	eax
d3:			dec	eax
d4:			dec	eax
d5:			dec	eax
				sub	eax, dword ptr [esp+4]
				ret	4
Borland	endp
;....................................................................................................................................

comment		* slen2 by Hutch  *

align 4
Hutch	proc item:DWORD
			push	edi
			push	esi
			mov	eax, [esp+12]
			mov	ecx, eax                ; copy EAX to ECX
			add	ecx, 3                  ; align up by 4
			and	ecx, -4       
			sub	ecx, eax                ; calculate any misalignment in ecx
			mov	esi, ecx                ; store ECX in ESI
			jz		proceed
			sub	eax, 1
  @@:
			add	eax, 1
			cmp BYTE PTR [eax], 0       ; scan for terminator for
			je		quit                     ; up to the 1st 3 bytes
			sub	ecx, 1
			jns	@B
			jmp	proceed
  quit:
			sub	eax, [esp+12]           ; calculate length if terminator
			jmp	outa_here               ; is found in 1st 3 bytes
  ; ----------------
  proceed:                      ; proceed with the rest
			lea	edx, [eax+3]            ; pointer+3 used in the end
align 4
  @@:     
			mov	edi, [eax]              ; read first 4 bytes
			add	eax, 4                  ; increment pointer
			lea	ecx, [edi-01010101h]    ; subtract 1 from each byte
			not	edi                     ; invert all bytes
			and	ecx, edi                ; and these two
			and	ecx, 80808080h    
			jz		@B                       ; no zero bytes, continue loop
			test	ecx, 00008080h         ; test first two bytes
			jnz	@F
			shr	ecx, 16                 ; not in the first 2 bytes
			add	eax, 2
  @@:
			shl	cl, 1                   ; use carry flag to avoid branch
			sbb	eax, edx                ; compute length
			add	eax, esi
  outa_here:
			pop	esi
			pop	edi
			ret	 4
Hutch endp
;....................................................................................................................................


comment		* StrLen Lingo SSE2  *
Align 16
@@1e:
					bsf				eax, edx
					ret				4
Align 16
LingoSSE2	proc				lpstri:DWORD
  					mov				eax, [esp+4]
					mov     			ecx, eax
					and				eax, -16	
					and				ecx, 15

					movdqa			xmm2, [eax]
					pxor    			xmm1, xmm1
					pcmpeqb		xmm2, xmm1
					pxor				xmm3, xmm3
					pmovmskb	edx, xmm2
					sar				edx, cl
 					test				edx, edx
					jnz				@@1e

					pcmpeqb		xmm3, [eax+16]
					pxor				xmm2, xmm2
	   				pmovmskb	ecx, xmm3		
					add				ecx, edx
					jne				@@AA1

					pcmpeqb		xmm2, [eax+32]
					pxor				xmm0, xmm0
	   				pmovmskb	ecx, xmm2		
					add				ecx, edx
					jne				@@AA2

					pcmpeqb		xmm0, [eax+48]
					pxor				xmm2, xmm2
	   				pmovmskb	ecx, xmm0		
					add				ecx,edx
					jne				@@AA3

					pcmpeqb		xmm2, [eax+64]
					pxor				xmm1, xmm1
	   				pmovmskb	ecx, xmm2		
					add				ecx,edx
					jne				@@AA4
@@:
					movdqa			xmm0, [eax+80]
					movdqa			xmm2, [eax+80+1*16]
					movdqa			xmm3, [eax+80+2*16]
					movdqa			xmm4, [eax+80+3*16]
					movdqa			xmm5, [eax+80+4*16]
					movdqa			xmm6, [eax+80+5*16]
					movdqa			xmm7, [eax+80+6*16]
					pcmpeqb		xmm0, xmm1
 					pcmpeqb		xmm2, xmm1
					pcmpeqb		xmm3, xmm1
					pcmpeqb		xmm4, xmm1
					pcmpeqb		xmm5, xmm1
					pcmpeqb		xmm6, xmm1
					pcmpeqb		xmm7, xmm1
					por				xmm0,xmm2
					por				xmm3,xmm4
					por				xmm0,xmm3
					por				xmm5,xmm6
					por				xmm0,xmm7
					por				xmm0,xmm5
               		pmovmskb	edx, xmm0
            		add				eax, 7*16
					add				edx, ecx
					je					@b
@@:
  					movdqa			xmm0, [eax+80-7*16]
					pcmpeqb		xmm0, xmm1    
	   				pmovmskb	edx, xmm0
					add				eax, 16
					add				edx, ecx
					je					@b
					sub				eax, [esp+4]
					bsf				edx, edx
					lea				eax, [eax+edx+80-7*16-16]
					ret				4
Align 16
@@AA1:
					sub				eax, [esp+4]
					bsf				ecx, ecx
					lea				eax,[eax+ecx+16]
					ret				4
Align 16
@@AA2:
					sub				eax, [esp+4]
					bsf				ecx, ecx
					lea				eax,[eax+ecx+32]
					ret				4
Align 16
@@AA3:
					sub				eax, [esp+4]
					bsf				ecx, ecx
					lea				eax,[eax+ecx+48]
					ret				4
Align 16
@@AA4:
					sub				eax, [esp+4]
					bsf				ecx, ecx
					lea				eax,[eax+ecx+64]
					ret				4
LingoSSE2	endp
;.................................................................................................................................................................

comment		* StrLen Lingo MMX  *
Align 16
@@1e3:
					bsf				eax, edx
					ret				4
Align 16
LingoMMX	proc				lpstri:DWORD
  					mov				eax, [esp+4]
					mov     			ecx, eax
					and				eax, -8	
					and				ecx, 7

					movq				mm0, [eax]
					pxor    			mm3, mm3
					pcmpeqb		mm0, mm3
					pmovmskb	edx, mm0
					sar				edx, cl
 					test				edx, edx
					jnz				@@1e3

					pcmpeqb		mm3, [eax+8]
 					pxor    			mm2, mm2
	   				pmovmskb	ecx, mm3
					add				ecx, edx
					jne				@@AA3

					pcmpeqb		mm2, [eax+16]
 					pxor    			mm0, mm0
	   				pmovmskb	ecx, mm2		
					add				ecx, edx
					jne				@@AA4

					pcmpeqb		mm0, [eax+24]
 					pxor    			mm2, mm2
	   				pmovmskb	ecx, mm0		
					add				ecx, edx
					jne				@@AA5

					pcmpeqb		mm2, [eax+32]
 					pxor    			mm1, mm1
	   				pmovmskb	ecx, mm2
					add				ecx, edx
					jne				@@AA6
@@:
					movq				mm0, [eax+40]
					movq				mm2, [eax+48]
					movq				mm3, [eax+56]
					movq				mm4, [eax+64]
					movq				mm5, [eax+72]
					movq				mm6, [eax+80]
					movq				mm7, [eax+88]
					pcmpeqb		mm0, mm1
 					pcmpeqb		mm2, mm1
					pcmpeqb		mm3, mm1
					pcmpeqb		mm4, mm1
					pcmpeqb		mm5, mm1
					pcmpeqb		mm6, mm1
					pcmpeqb		mm7, mm1
					por				mm0, mm2
					por				mm3, mm4
					por				mm0, mm3
					por				mm5, mm6
					por				mm0, mm7
					por				mm0, mm5
               		pmovmskb	edx, mm0
            		add				eax, 7*8
					add				edx, ecx
					je					@b
@@:
					movq				mm0, [eax+40-7*8]
					pcmpeqb		mm0, mm1
  	   				pmovmskb	edx, mm0
					add				eax, 8
					add				edx, ecx
					je					@b
					sub				eax, [esp+4]
					bsf				edx, edx
					lea				eax, [eax+edx+40-7*8-8]
					ret				4
Align 16
@@AA3:
					sub				eax, [esp+4]
					bsf				ecx, ecx
					lea				eax,[eax+ecx+8]
					ret				4
Align 16
@@AA4:
					sub				eax, [esp+4]
					bsf				ecx, ecx
					lea				eax,[eax+ecx+16]
					ret				4
Align 16
@@AA5:
					sub				eax, [esp+4]
					bsf				ecx, ecx
					lea				eax,[eax+ecx+24]
					ret				4
Align 16
@@AA6:
					sub				eax, [esp+4]
					bsf				ecx, ecx
					lea				eax,[eax+ecx+32]
					ret				4
LingoMMX	endp
;-------------------------------------------------------------------------------

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start
