.nolist
    include     \masm32\include\masm32rt.inc    ; defaults to .386
    .586
    include     \masm32\macros\timers.asm      ; requires a pentium

    LOOPCOUNT equ 10000000

    PROCS TEXTEQU <RatchN,Lingo32>
    LastString= 999
    SIZES TEXTEQU <0,1,2,3,5,8,13,22,39,55,89,144,239,LastString>

    HPROC TEXTEQU <szLen>        ; Function to calculate length for header
.listall
    %FOR proc,<PROCS>
        proc proto :DWORD
    ENDM

    MAXWIDTH  equ 20
    HDRWIDTH  equ 9
    COLWIDTH  equ 5

.data

 
    %FOR extra,<0,1,2,3>
        %FOR len,<SIZES>
            align 16
            db extra dup (0)
            str&extra&b&len& db len dup (31),0
            db 8 dup (33h),0    ; possible next string
        ENDM
    ENDM

.code
align 16

sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD
    .if DDalign == 0                    ; align left?
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1                ; align right?
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4

sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>       ; Default is align left
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM

align 16
start:
    ; make a real test string with all ascii characters-
    %FOR extra,<0,1,2,3>
        mov edx,offset str&extra&bLastString
        mov al,1
        mov ecx,LastString
@@:     
        mov [edx],al
        inc al
        .if al==0
            inc al
        .endif
        inc edx
        dec ecx
        jnz @b
    endm        
         
    print chr$("Test routines for correctness:",13,10)
    %FOR extra,<0,1,2,3>
        print chr$("&extra& byte misalignment",13,10)
        %FOR proc,<PROCS>
            print fld$(chr$("&proc&"),HDRWIDTH)
            %FOR len,<SIZES>
                invoke proc,ADDR str&extra&b&len&
                ;invoke proc,ADDR str2b&len&
                print fld$(sstr$(eax),COLWIDTH,1)
            ENDM
            print chr$(13,10)
        ENDM
    ENDM

    print chr$(13,10)
    print fld$(chr$("Proc/Bytes"),HDRWIDTH)

    %FOR len,<SIZES>
        invoke HPROC, ADDR str0b&len&
        print fld$(sstr$(eax),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("=========="),HDRWIDTH)
    %FOR len,<SIZES>
        invoke StrLen,ADDR str0b&len&
        print fld$(" ====",COLWIDTH)
    ENDM
    print chr$(13,10)

    %FOR extra,<0,1,2,3>
        print chr$(13,10)
        print chr$("&extra& byte misalignment",13,10)
       %FOR proc,<PROCS>
            print fld$(chr$("&proc&"),HDRWIDTH)
            %FOR len,<SIZES>
                counter_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
                invoke proc,ADDR str&extra&b&len&
                counter_end
                mov ebx,eax
                print fld$(sstr$(ebx),COLWIDTH,1)
            ENDM
        print chr$(13,10)
        ENDM
    ENDM
    mov   eax,input(13,10,"Press enter to exit...")
    exit

; --------------------- Routines under test ---------------------------------------------

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

;...........................................................................................
comment * StrLen Ratch New *
Align 16
RatchN	proc			lpst:DWORD
			mov			eax,[esp+4] 
Labe_0: 
			test        	al, 3 
			je          	Labe_1 
			test        	byte ptr [eax], 0FFh 
			je          	Labe_4
Labe_Begin:
			inc         	eax  
			jmp         	Labe_0 
Labe_1: 
			mov         ecx, 80808080h 
Labe_2:
			mov			edx, [eax] 
			and			edx, 7F7F7F7Fh 
			add         	eax, 4 
			sub         	edx, 1010101h 
			and         	edx, ecx 
			je          	Labe_2 
			sub         	eax, 5 
Labe_3:
			inc         	eax  
			ror         	edx, 8 
			jnc         	Labe_3 

			test			byte ptr [eax],0FFH          ;test if 080H is masquerading as a zero byte
			js				Labe_Begin
  Labe_4:
			sub         	eax, [esp+4] 
			ret         	4 
RatchN	endp

;...........................................................................................
comment * StrLen Lingo32 *
Align 16
db  8Dh, 0A4h, 24h, 0,0,0,0, 8Bh,0FFh,90h
Lingo32	proc		lpst:DWORD
				mov		eax, [esp+4]
                mov		edx, 80808080h
				test		eax, 3
				jne		NotAlign
   				mov		ecx, [eax]
 @@1s:
				add		eax, 4
				add		ecx, 0FEFEFEFFh
				test		edx, ecx
				mov		ecx, [eax]
				je			@@1s

				mov		ecx, [eax-4]
				sub		eax, 4

				test		ecx, 0FFh
				je			C3eV_minus4 
				test		ecx, 0FF00h
				je			C3eV_minus3 
				test		ecx, 0FF0000h
				je			C3eV_minus2
				test		ecx, 0FF000000h
				je			C3eV_minus1
@@:
  				lea		edx, [ecx+0FEFEFEFFh]
				not		ecx
                and		ecx, 80808080h
				add		eax, 4
                and		edx, ecx
				mov		ecx, [eax]
            	je         @b

				add		eax,-4
				shr		edx, 8
				jc			@f
				add		eax, 1  
				shr		edx, 8
				jc			@f
				add		eax, 1  
				shr		edx, 8
				jc			@f
				add		eax, 1  
@@:
				sub		eax, [esp+4]
				ret		4
align 16
NotAlign:
				test		byte ptr [eax],0FFh
				lea		eax, [eax+1]
				je			@f
				test		eax, 3
				jne		NotAlign
				mov		ecx, [eax]
				je			@@1s
align 16
@@:
				add		eax,-1
				shr		edx, 8
				jc			@f
				add		eax, 1  
				shr		edx, 8
				jc			@f
				add		eax, 1  
 @@:
   				sub		eax, [esp+4]
				ret		4
align 16
C3eV_minus1:
				sub		eax, [esp+4]
				add		eax, 3
				ret 		4		
align 16
C3eV_minus2:
				sub		eax, [esp+4]
				add		eax, 2
				ret		4					
align 16
C3eV_minus3:                         
				sub		eax, [esp+4]
				add		eax, 1
				ret		4
align 16	
C3eV_minus4:                        
				sub		eax, [esp+4]
				ret		4                      		
Lingo32    endp
;...........................................................................................

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start
